'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * gulf-codemirror
 * Copyright (C) 2015-2016 Marcel Klehr <mklehr@gmx.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
var gulf = require('gulf'),
    textOT = require('ot-text').type;

var CodemirrorDocument = function (_gulf$EditableDocumen) {
  (0, _inherits3.default)(CodemirrorDocument, _gulf$EditableDocumen);

  function CodemirrorDocument(opts) {
    (0, _classCallCheck3.default)(this, CodemirrorDocument);

    opts.ottype = opts.ottype || textOT;

    var _this = (0, _possibleConstructorReturn3.default)(this, (CodemirrorDocument.__proto__ || (0, _getPrototypeOf2.default)(CodemirrorDocument)).call(this, opts));

    if (!opts.editorInstance) throw new Error('No codemirror instance was passed');
    _this.cm = opts.editorInstance;
    _this.oldval = '';

    _this.cm.on('change', _this.collectChanges = function () {
      return _this._onBeforeChange();
    });
    return _this;
  }

  (0, _createClass3.default)(CodemirrorDocument, [{
    key: 'close',
    value: function close() {
      (0, _get3.default)(CodemirrorDocument.prototype.__proto__ || (0, _getPrototypeOf2.default)(CodemirrorDocument.prototype), 'close', this).call(this);
      this.cm.off('change', this.collectChanges);
    }
  }, {
    key: '_setContent',
    value: function _setContent(newcontent) {
      this.cm.setValue(this.oldval = newcontent);
      return _promise2.default.resolve();
    }
  }, {
    key: '_onChange',
    value: function _onChange(cs) {
      var _this2 = this;

      // remember selection
      var oldSel = this.cm.listSelections().map(function (sel) {
        return [_this2.cm.indexFromPos(sel.head), _this2.cm.indexFromPos(sel.anchor)];
      });
      var oldScrollPos = this.cm.getScrollInfo();

      // apply changes
      cm.setValue(this.oldval = this.ottype.apply(this.oldval, cs));

      // take care of selection
      var newSel = oldSel.map(function (sel) {
        return _this2.ottype.transformSelection(sel, cs);
      }).map(function (transformed) {
        return { head: _this2.cm.posFromIndex(transformed[0]), anchor: _this2.cm.posFromIndex(transformed[1]) };
      });
      this.cm.setSelections(newSel);
      this.cm.scrollTo(oldScrollPos.left, oldScrollPos.top);

      return _promise2.default.resolve();
    }
  }, {
    key: '_onBeforeChange',
    value: function _onBeforeChange() {
      var cs = [],
          oldval = this.oldval,
          newval = this.cm.getValue();

      // The following code is taken from shareJS:
      // https://github.com/share/ShareJS/blob/3843b26831ecb781344fb9beb1005cfdd2/lib/client/textarea.js

      if (oldval === newval) return _promise2.default.resolve();

      var commonStart = 0;
      while (oldval.charAt(commonStart) === newval.charAt(commonStart)) {
        commonStart++;
      }
      var commonEnd = 0;
      while (oldval.charAt(oldval.length - 1 - commonEnd) === newval.charAt(newval.length - 1 - commonEnd) && commonEnd + commonStart < oldval.length && commonEnd + commonStart < newval.length) {
        commonEnd++;
      }
      if (oldval.length !== commonStart + commonEnd) {
        if (commonStart) cs.push(commonStart);
        cs.push({ d: oldval.length - commonStart - commonEnd });
      }
      if (newval.length !== commonStart + commonEnd) {
        if (commonStart && !cs.length) cs.push(commonStart);
        cs.push(newval.slice(commonStart, newval.length - commonEnd));
      }

      this.oldval = newval;
      this.submitChange(cs);
      return _promise2.default.resolve();
    }
  }]);
  return CodemirrorDocument;
}(gulf.EditableDocument);

module.exports = CodemirrorDocument;